<html>
<head>
<title>OgreOptimisedUtil.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreOptimisedUtil.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreOptimisedUtil_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OptimisedUtil_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OptimisedUtil_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreEdgeListBuilder_8h.html">OgreEdgeListBuilder.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;cstddef&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00047"></a><a class="code" href="classOgre_1_1OptimisedUtil.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">private</span>:
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>&amp; rhs); <span class="comment">/* do nothing, should not use */</span>
<a name="l00053"></a>00053         <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>&amp; rhs); <span class="comment">/* do not use */</span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keyword">protected</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1OptimisedUtil.html#af1214c854c521f84997b5ddf77f1a3a5">00057</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>* <a class="code" href="classOgre_1_1OptimisedUtil.html#af1214c854c521f84997b5ddf77f1a3a5" title="Store a pointer to the implementation.">msImplementation</a>;
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>* _detectImplementation(<span class="keywordtype">void</span>);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00063"></a>00063         <span class="comment">// Default constructor</span>
<a name="l00064"></a><a class="code" href="classOgre_1_1OptimisedUtil.html#a4f137d0ced0f82abd042d9b4eb99b105">00064</a>         <a class="code" href="classOgre_1_1OptimisedUtil.html#a4f137d0ced0f82abd042d9b4eb99b105">OptimisedUtil</a>(<span class="keywordtype">void</span>) {}
<a name="l00065"></a>00065         <span class="comment">// Destructor</span>
<a name="l00066"></a><a class="code" href="classOgre_1_1OptimisedUtil.html#a7d548511ecbd6b39d6d1689ce30db8f2">00066</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OptimisedUtil.html#a7d548511ecbd6b39d6d1689ce30db8f2">~OptimisedUtil</a>() {}
<a name="l00067"></a>00067 
<a name="l00073"></a><a class="code" href="classOgre_1_1OptimisedUtil.html#aec3039ddfa064375bb4065a4415a8eda">00073</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OptimisedUtil.html" title="Utility class for provides optimised functions.">OptimisedUtil</a>* <a class="code" href="classOgre_1_1OptimisedUtil.html#aec3039ddfa064375bb4065a4415a8eda" title="Gets the implementation of this class.">getImplementation</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> msImplementation; }
<a name="l00074"></a>00074 
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> softwareVertexSkinning(
<a name="l00100"></a>00100             <span class="keyword">const</span> <span class="keywordtype">float</span> *srcPosPtr, <span class="keywordtype">float</span> *destPosPtr,
<a name="l00101"></a>00101             <span class="keyword">const</span> <span class="keywordtype">float</span> *srcNormPtr, <span class="keywordtype">float</span> *destNormPtr,
<a name="l00102"></a>00102             <span class="keyword">const</span> <span class="keywordtype">float</span> *blendWeightPtr, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* blendIndexPtr,
<a name="l00103"></a>00103             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* <span class="keyword">const</span>* blendMatrices,
<a name="l00104"></a>00104             <span class="keywordtype">size_t</span> srcPosStride, <span class="keywordtype">size_t</span> destPosStride,
<a name="l00105"></a>00105             <span class="keywordtype">size_t</span> srcNormStride, <span class="keywordtype">size_t</span> destNormStride,
<a name="l00106"></a>00106             <span class="keywordtype">size_t</span> blendWeightStride, <span class="keywordtype">size_t</span> blendIndexStride,
<a name="l00107"></a>00107             <span class="keywordtype">size_t</span> numWeightsPerVertex,
<a name="l00108"></a>00108             <span class="keywordtype">size_t</span> numVertices) = 0;
<a name="l00109"></a>00109 
<a name="l00124"></a>00124         <span class="keyword">virtual</span> <span class="keywordtype">void</span> softwareVertexMorph(
<a name="l00125"></a>00125             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t,
<a name="l00126"></a>00126             <span class="keyword">const</span> <span class="keywordtype">float</span> *srcPos1, <span class="keyword">const</span> <span class="keywordtype">float</span> *srcPos2,
<a name="l00127"></a>00127             <span class="keywordtype">float</span> *dstPos,
<a name="l00128"></a>00128             <span class="keywordtype">size_t</span> pos1VSize, <span class="keywordtype">size_t</span> pos2VSize, <span class="keywordtype">size_t</span> dstVSize, 
<a name="l00129"></a>00129             <span class="keywordtype">size_t</span> numVertices,
<a name="l00130"></a>00130             <span class="keywordtype">bool</span> morphNormals) = 0;
<a name="l00131"></a>00131 
<a name="l00141"></a>00141         <span class="keyword">virtual</span> <span class="keywordtype">void</span> concatenateAffineMatrices(
<a name="l00142"></a>00142             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; baseMatrix,
<a name="l00143"></a>00143             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* srcMatrices,
<a name="l00144"></a>00144             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* dstMatrices,
<a name="l00145"></a>00145             <span class="keywordtype">size_t</span> numMatrices) = 0;
<a name="l00146"></a>00146 
<a name="l00158"></a>00158         <span class="keyword">virtual</span> <span class="keywordtype">void</span> calculateFaceNormals(
<a name="l00159"></a>00159             <span class="keyword">const</span> <span class="keywordtype">float</span> *positions,
<a name="l00160"></a>00160             <span class="keyword">const</span> <a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html" title="Basic triangle structure.">EdgeData::Triangle</a> *triangles,
<a name="l00161"></a>00161             <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a> *faceNormals,
<a name="l00162"></a>00162             <span class="keywordtype">size_t</span> numTriangles) = 0;
<a name="l00163"></a>00163 
<a name="l00180"></a>00180         <span class="keyword">virtual</span> <span class="keywordtype">void</span> calculateLightFacing(
<a name="l00181"></a>00181             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos,
<a name="l00182"></a>00182             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>* faceNormals,
<a name="l00183"></a>00183             <span class="keywordtype">char</span>* lightFacings,
<a name="l00184"></a>00184             <span class="keywordtype">size_t</span> numFaces) = 0;
<a name="l00185"></a>00185 
<a name="l00200"></a>00200         <span class="keyword">virtual</span> <span class="keywordtype">void</span> extrudeVertices(
<a name="l00201"></a>00201             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos,
<a name="l00202"></a>00202             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist,
<a name="l00203"></a>00203             <span class="keyword">const</span> <span class="keywordtype">float</span>* srcPositions,
<a name="l00204"></a>00204             <span class="keywordtype">float</span>* destPositions,
<a name="l00205"></a>00205             <span class="keywordtype">size_t</span> numVertices) = 0;
<a name="l00206"></a>00206     };
<a name="l00207"></a>00207 
<a name="l00212"></a>00212     <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00213"></a><a class="code" href="group__Math.html#gabb1e4ba22444c1bbf72e6aa66130cd01">00213</a>     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> T* <a class="code" href="group__Math.html#gabb1e4ba22444c1bbf72e6aa66130cd01" title="Returns raw offseted of the given pointer.">rawOffsetPointer</a>(T* ptr, ptrdiff_t offset)
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215         <span class="keywordflow">return</span> (T*)((<span class="keywordtype">char</span>*)(ptr) + offset);
<a name="l00216"></a>00216     }
<a name="l00217"></a>00217 
<a name="l00222"></a>00222     <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00223"></a><a class="code" href="group__Math.html#gad80b2abc7821c70d6ea086d87ed0ae18">00223</a>     <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">void</span> <a class="code" href="group__Math.html#gad80b2abc7821c70d6ea086d87ed0ae18" title="Advance the pointer with raw offset.">advanceRawPointer</a>(T*&amp; ptr, ptrdiff_t offset)
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225         ptr = <a class="code" href="group__Math.html#gabb1e4ba22444c1bbf72e6aa66130cd01" title="Returns raw offseted of the given pointer.">rawOffsetPointer</a>(ptr, offset);
<a name="l00226"></a>00226     }
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="preprocessor">#endif  // __OptimisedUtil_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
